// Only for LINUX (DEBIAN) / FOX BOARD G20 - ACME SYSTEMS
// ALESSIO LOMBARDO 5B INFORMATICA 2012/2013 - ITIS VITTORIO EMANUELE III - PALERMO (ITALY)

#include "robotlib.c"

int main(int argc,char *argv[]){
   int i; //Variabile General Purpose
   char buffer[150]; //Buffer General Purpose
   int par=-1;
   float credit;
   struct sockaddr_in server_addr;
   struct sockaddr_in client_addr;
   int sd_server;
   int sd_client;
   int mode=0;
   //0: modalita' console attiva (mai attivata nessun'altra modalita')
   //1: modalita' socket attiva
   //2: modalita' sms attiva
   //4: console attiva (gia' attivata un'altra modalita' in precedenza)

   int webcam_time;
   int webcam_resolution;
   char webcam_res[10];
   int webcam_fps;
   int webcam_fps_t;
   int measure_env_time=300;
   int measure_imu_time=50;
   struct structIMU IMU;
   struct structGPS GPS;

   int smotorpos=0;
   int sonarpos=0;

   int modechasing=0;

   int colorled;
   int bigled;
   int colorspeed;
   int colorchildpid=0;
   int turnsignal;
   //0: figlio da creare
   //!=0: figlio gia' creato
   int turnsignalschildpid=0;
   //0: figlio da creare
   //!=0: figlio gia' creato
   int screensaverdelay;
   int screensaverchildpid=0;
   //0: figlio da creare
   //!=0: figlio gia' creato
   int movementchildpid;
   int shutdowntimer=-1;

   int hornchildpid=0;
   //0: figlio da creare
   //!=0: figlio gia' creato

   float temperature;
   float altitude;
   float pressure;
   int range;
   int rangev[15];
   int light;
   int lightv[15];

   int batteryvalue;

   signal(SIGTSTP,SIG_IGN);
   //signal(SIGALRM,sigalrm);

   FILE *fd_script=0;
   FILE *fd_script_s=0;
   FILE *fd_script_r=0;
   int script_file=0;
   int script_status;
   int save_script=0;
   int script_file_s=0;
   int script_file_s_t=0;

   int step=0; //posizione prevista dei motori
   int memd=shmget(IPC_PRIVATE, sizeof(int)*2, SHM_R | SHM_W | IPC_CREAT | IPC_EXCL);
   int *pos=(int *)shmat(memd, 0, SHM_R | SHM_W);
   pos[0]=0; //stepper motor position
   pos[1]=0; //sonar motor position

   battery_status(&batteryvalue);
   e12volt_on();

   int fd_i2c=openi2c();
   daisy7_set(fd_i2c);

   FILE *fd_motor;
   if((fd_motor=fopen("save/motor","r"))!=NULL){
      fscanf(fd_motor,"%d,%d",&pos[0],&pos[1]);
      fclose(fd_motor);
   }else{
      printf("Errore: Impossibile leggere le posizioni dei motori\n");
   }

   FILE *fd_webcam;
   if((fd_webcam=fopen("save/webcam","r"))!=NULL){
      fscanf(fd_webcam,"%d,%d,%d,%s",&webcam_time,&webcam_fps,&webcam_resolution,&webcam_res);
      fclose(fd_webcam);
   }else{
      printf("Errore: Impossibile leggere la configurazione della webcam\n");
   }

   if(argc>2){
      par=atoi(argv[2]);
   }
   do{
      char ch[3];
      if((argc>1)&&(!strcmp(argv[1],"-s"))){
         if(fd_script==0){
            printf("\033[31;43;1mEXECUTE SCRIPT %s\033[m\n",argv[2]);
            if((fd_script = fopen(argv[2],"r"))==NULL){
               printf("\nErrore: Impossibile aprire lo script\n");
               //exit(1);
            }
         }
         if(feof(fd_script)){
            printf("\033[31;43;1mEXIT\033[m\n");
            closerobot(fd_i2c,pos,webcam_time,webcam_fps,webcam_resolution,webcam_res);
            fclose(fd_script);
            exit(0);
         }
         fscanf(fd_script,"%c%c%c\n\n",&ch[0],&ch[1],&ch[2]);
         if(ch[0]=='/'){
            do{
               ch[0]=fgetc(fd_script);
            }while(ch[0]!='\n');
            ch[0]='X';
         }else if(ch[0]=='<'){
            fscanf(fd_script,"%s\n\n",buffer);
            ch[0]='X';
         }else if(ch[2]==';'){
            printf("\033[34;1mLetto il codice %c%c senza nessun parametro\033[m\n",ch[0],ch[1]);
         }else{
            fscanf(fd_script,"%d;\n\n",&par);
            if((ch[0]=='s')&&(ch[1]=='c')){
               printf("\033[34;1mAttesa per %d secondi\033[m\n",par);
               sleep(par);
               ch[0]='X';
            }else if((ch[0]=='m')&&(ch[1]=='s')){
               printf("\033[34;1mAttesa per %d millisecondi\033[m\n",par);
               usleep(par*1000);
               ch[0]='X';
            }else if((ch[0]=='u')&&(ch[1]=='s')){
               printf("\033[34;1mAttesa per %d microsecondi\033[m\n",par);
               usleep(par);
               ch[0]='X';
            }else{
               printf("\033[34;1mLetto il codice %c%c con parametro %d\033[m\n",ch[0],ch[1],par);
            }
         }
      }else if(mode==1){
         for(i=0;i<150;i++){
            buffer[i]='\0';
         }
         recv(sd_client, buffer, sizeof(buffer),0);
         printf("\033[34;1mRicevuto il codice %c%c\033[m\n",buffer[0],buffer[1]);
         ch[0]=buffer[0];
         ch[1]=buffer[1];
         for(i=0;i<150;i++){
            buffer[i]='\0';
         }
      }else if(mode==2){
         for(i=0;i<150;i++){
            buffer[i]='\0';
         }
         par=sms('r',buffer);
         if(buffer[0]!='X'){
            if((par==-1)||(par==99999)){
               printf("\033[34;1mRicevuto il codice %c%c senza nessun parametro\033[m\n",buffer[0],buffer[1]);
            }else{
               printf("\033[34;1mRicevuto il codice %c%c con parametro %d\033[m\n",buffer[0],buffer[1],par);
            }
         }
         ch[0]=buffer[0];
         ch[1]=buffer[1];
      }else if((argc==1)||(mode==4)){
         system("clear");

         //      0123456789          0123456789          0123456789          0123456789          0123456789          0123456789          0123456789
         //                0123456789          0123456789          0123456789          0123456789          0123456789          0123456789

         printf("\033[31;1m*****************************************************************************************************************************\n");
         printf("*    GESTIONE ROBOT Versione 10.0 - ALESSIO LOMBARDO 5B INF - A.S. 2012/2013 - ACME SYSTEMS FOX BOARD G20 - LINUX DEBIAN    *\n");
         printf("*****************************************************************************************************************************\n");
         if(battery_status(&batteryvalue)==1){
            printf("* %s                                              BATTERIA: %3d%% (IN CARICA) *\n",data_ora(buffer),batteryvalue);
         }else{
            printf("* %s                                                          BATTERIA: %3d%% *\n",data_ora(buffer),batteryvalue);
         }
         printf("*****************************************************************************************************************************\033[32;1m\n"); 
         printf("*****************************************************************************************************************************\n");
         printf("* Data e Orario                                               * Illuminazione                                               *\n");
         printf("* 01  Visualizza                                              * 41  Led destro                                              *\n");         
         printf("* 02  Aggiorna da Server (Internet)                           * 42  Led sinistro                                            *\n");
         printf("* 03  Aggiorna da Satellite (GPS)                             * 43  Frecce                                                  *\n");         
         printf("*                                                             * 44  Casuale                                                 *\n");          
         printf("* Webcam                                                      * 45  Faro anteriore                                          *\n");
         printf("* 11  Streaming Video                                         *                                                             *\n");
         printf("* 12  Scatta Fotografie                                       * GPS                                                         *\n");
         printf("* 13  Streaming video e Scatta Fotografie                     * 51  Orario e Coordinate satellitari                         *\n");
         printf("* 14  Disattiva                                               * 52  Stringa NMEA                                            *\n");
         printf("* 15  Elimina tutte le Fotografie memorizzate                 * 53  Converti Coordinate per Google Maps                     *\n");
         printf("* 16  Modifica la frequenza degli scatti fotografici          * 54  Salva dati sul Database                                 *\n");
         printf("* 17  Modifica la risoluzione                                 *                                                             *\n");
         printf("* 18  Modifica fotogrammi per secondo                         * Altre funzionalita'                                         *\n");
         printf("* 19  Visualizza configurazioni                               * 61  Individua luce e distanza                               *\n"); 
         printf("*                                                             * 62  Visualizza carica della batteria                        *\n");
         printf("* Misurazioni                                                 * 63  Visualizza credito residuo (solo SIM TIM)               *\n");
         printf("* 21  Visualizza misurazioni ambientali                       *                                                             *\n");
         printf("* 22  Visualizza misurazioni inerziali                        * Script                                                      *\n");
         printf("* 23  Monitora ambiente                                       * 71  Visualizza lista degli Script                           *\n");
         printf("* 24  Interrompi monitoraggio dell'ambiente                   * 72  Esecuzione di uno Script                                *\n");
         printf("* 25  Monitora posizione (solo modalita' Socket)              * 73  Visualizza uno Script                                   *\n");
         printf("* 26  Salva misurazioni ambientali sul Database               * 74  Elimina uno Script                                      *\n");
         printf("* 27  Salva misurazioni inerziali sul Database                * 75  Registrazione di uno Script                             *\n");
         printf("*                                                             * 76  Interrompi registrazione in corso                       *\n");
         printf("* Movimento                                                   *                                                             *\n");
         printf("* 31  Accensione dei Motori                                   * Gestione comunicazioni                                      *\n");
         printf("* 32  Spegnimento dei Motori                                  * 81  Abilita gestione del robot tramite socket               *\n");
         printf("* 33  Spostamento manuale motori e sonar                      * 82  Abilita gestione del robot tramite sms                  *\n");
         printf("* 34  Spostamento automatico ruote anteriori                  * 83  Abilita gestione del robot tramite console              *\n");
         printf("* 35  Avanzamento automatico ruote posteriori                 *                                                             *\n");
         printf("* 36  Spostamento automatico sonar                            * Uscita                                                      *\n");
         printf("* 37  Visualizza posizioni (motore anteriore e sonar)         * 91  Esci dal software di gestione                           *\n");
         printf("* 38  Reset posizioni (motore anteriore e sonar)              * 92  Spegni il robot                                         *\n");
         printf("*                                                             *                                                             *\n");
         printf("*****************************************************************************************************************************\n");
         printf("* Scelta:                                                                                                                   *\n");
         printf("*****************************************************************************************************************************\n\033[m\033[2A\033[10C");
         scanf("%s",ch);
         printf("\n");
      }else{
         strcpy(ch,argv[1]);
      }
      switch(ch[0]){
         case 'X':
            break;
         case '0':
            printf("Data e Orario - ");
            switch(ch[1]){
               case '1':
                  printf("Visualizza\n");
                  sprintf(buffer,"%s\n",data_ora(buffer));
                  printrobot(mode,sd_client,buffer);
                  break;
               case '2':{
                  char buffer1[70];
                  printf("Aggiorna da Server (Internet)\n");
                  system("ntpdate time.ien.it > /dev/null");
                  system("hwclock -w");
                  sprintf(buffer1,"Data e Orario aggiornati: %s\n",data_ora(buffer));
                  printrobot(mode,sd_client,buffer1);
                  break;
               }
               case '3':{
                  char buffer1[70];
                  printf("Aggiorna da Satellite (GPS)\n");
                  GPS=gps();
                  sprintf(buffer,"date -s %s > /dev/null",GPS.time_hms);
                  system(buffer);
                  system("hwclock -w");
                  sprintf(buffer1,"Data e Orario aggiornati: %s\n",data_ora(buffer));
                  printrobot(mode,sd_client,buffer1);
                  break;
               }
               case '9':
                  printf("Attiva Screensaver\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Ritardo attivazione (in secondi, 0 = Disattivazione):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     screensaverdelay=atoi(buffer);
                     par=screensaverdelay;
                  }else if(mode==2){
                     screensaverdelay=par;
                  }else if(argc<=2){
                     printf("Richiesta Parametro - Ritardo attivazione (in secondi, 0 = Disattivazione):\n");
                     scanf("%d",&screensaverdelay);
                     par=screensaverdelay;
                  }else{
                     screensaverdelay=par;
                  }
                  if(screensaverdelay<=0){
                     printrobot(mode,sd_client,"Errore: Ritardo attivazione minore di 0\n");  
                  }else{
                     printrobot(mode,sd_client,"Screensaver attivato. Premere ^Z per disattivarlo quando e' gia' partito\n");  
                     screensaverchildpid=fork();
                     if(screensaverchildpid==0){
                        char str1[9];
                        char str2[9];
                        sprintf(str1,"%d",42100);
                        sprintf(str2,"%d",screensaverdelay);
                        execl("./matricurses/matricurses","./matricurses/matricurses",str1,str2,NULL);
                     }else{
                        wait(NULL);
                     }
                     system("reset");
                  }
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '1':
            printf("Webcam - ");
            switch(ch[1]){
               case '1':
                  printf("Streaming Video\n");
                  webcam_video(webcam_res,webcam_fps);
                  sleep(1);
                  printrobot(mode,sd_client,"Streaming Webcam in corso sulla porta 4300\n");
                  break;
               case '2':
                  printf("Scatta Fotografie\n");
                  webcam_picture(webcam_time,webcam_res);
                  sleep(1);
                  printrobot(mode,sd_client,"Scatti fotografici in corso\n");
                  break;
               case '3':
                  printf("Streaming video e Scatta Fotografie\n");
                  webcam_video_picture(webcam_time,webcam_res);
                  sleep(1);
                  printrobot(mode,sd_client,"Streaming video e Scatti fotografici in corso\n");
                  break;
               case '4':
                  printf("Disattiva\n");
                  if(webcam_off()==0){;
                     printrobot(mode,sd_client,"Webcam Disattivata\n");
                  }else{
                     printrobot(mode,sd_client,"Errore: Webcam gia' Disattivata\n");
                  }
                  break;
               case '5':
                  printf("Elimina tutte le Fotografie memorizzate\n");
                  if(webcam_deletep()==0){
                     printrobot(mode,sd_client,"Tutte le Fotografie sono state eliminate\n");
                  }else{
                     printrobot(mode,sd_client,"Errore: Nessuna Fotografia da eliminare\n");
                  }
                  break;
               case '6':
                  printf("Modifica la frequenza degli scatti fotografici\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire nuova frequenza (in millisecondi):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     webcam_time=atoi(buffer);
                     par=webcam_time;
                  }else if(mode==2){
                     webcam_time=par;
                  }else if(argc<=2){
                     printf("Inserire nuova frequenza (in millisecondi): ");
                     scanf("%d",&webcam_time);
                     par=webcam_time;
                  }else{
                     webcam_time=par;
                  }
                  printrobot(mode,sd_client,"Frequenza modificata\n"); 
                  break;
               case '7':
                  printf("Modifica la risoluzione\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire nuova risoluzione (1: 320x240   2: 640x480):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     webcam_resolution=atoi(buffer);
                     par=webcam_resolution;
                  }else if(mode==2){
                     webcam_resolution=par;
                  }else if(argc<=2){
                     printf("Inserire nuova risoluzione (1: 320x240   2: 640x480): ");
                     scanf("%d",&webcam_resolution);
                     par=webcam_resolution;
                  }else{
                     webcam_resolution=par;
                  }
                  if(webcam_resolution==1){
                     strcpy(webcam_res,"320x240");
                     printrobot(mode,sd_client,"Risoluzione modificata\n"); 
                  }else if(webcam_resolution==2){
                     strcpy(webcam_res,"640x480");
                     printrobot(mode,sd_client,"Risoluzione modificata\n"); 
                  }else{
                     printrobot(mode,sd_client,"Errore: Risoluzione non modificata. Scegliere correttamente.\n"); 
                  }
                  break;
               case '8':
                  printf("Modifica fotogrammi per secondo\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire fotogrammi per secondo (Max: 30 FPS):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     webcam_fps_t=atoi(buffer);
                     par=webcam_fps_t;
                  }else if(mode==2){
                     webcam_fps_t=par;
                  }else if(argc<=2){
                     printf("Inserire fotogrammi per secondo (Max: 30 FPS): ");
                     scanf("%d",&webcam_fps_t);
                     par=webcam_fps_t;
                  }else{
                     webcam_fps_t=par;
                  }
                  if(webcam_fps_t<=30){
                     webcam_fps=webcam_fps_t;
                     printrobot(mode,sd_client,"Frame Rate modificato\n"); 
                  }else{
                     printrobot(mode,sd_client,"Errore: Fotogrammi al secondo maggiori di 30\n"); 
                  }
                  break;
               case '9':
                  printf("Visualizza configurazioni\n");
                  sprintf(buffer,"Scatta Fotografia: ogni %d millisecondi   Risoluzione: %s   Frame Rate: %d fotogrammi al secondo\n",webcam_time,webcam_res,webcam_fps);
                  printrobot(mode,sd_client,buffer); 
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '2':
            printf("Misurazioni - ");
            switch(ch[1]){
               case '1':
                  printf("Visualizza misurazioni ambientali\n");
                  readTAP(fd_i2c,&temperature,&altitude,&pressure);
                  sonar(fd_i2c,&range,&light);
                  sprintf(buffer,"Temperatura: %.2f Gradi Celsius   Altitudine: %.2f Metri   Pressione: %.2f HPascal   Distanza sonar: %d cm   Luminosita': %d lum\n",temperature,altitude,pressure,range,light);
                  printrobot(mode,sd_client,buffer);
                  break;
               case '2':
                  printf("Visualizza misurazioni inerziali\n");
                  IMU=readIMU(fd_i2c,0);
                  sprintf(buffer,"Accelerometro X:%.4f Y:%.4f Z:%.4f   Giroscopio X:%.4f Y:%.4f Z:%.4f   Magnetometro X:%.4f Y:%.4f Z:%.4f\n",IMU.acc_X,IMU.acc_Y,IMU.acc_Z,IMU.gyro_X,IMU.gyro_Y,IMU.gyro_Z,IMU.mag_X,IMU.mag_Y,IMU.mag_Z);
                  printrobot(mode,sd_client,buffer);
                  break;
               case '3': 
                  printf("Monitora ambiente\n");
                  int measureechildpid=fork();
                  if(measureechildpid==0){
                     monitoring_env(fd_i2c,measure_env_time);
                  }else{
                     printrobot(mode,sd_client,"Monitoraggio ambientale attivato\n");
                  }
                  break;
               case '4':
                  printf("Interrompi monitoraggio dell'ambiente\n");
                  kill(measureechildpid,SIGTERM);
                  printrobot(mode,sd_client,"Monitoraggio ambientale disattivato\n");
                  break;
               case '5': 
                  printf("Monitora posizione (solo modalita' Socket)\n");
                  if(mode==1){
                     int measureichildpid=fork();
                     if(measureichildpid==0){
                        monitoring_imu(fd_i2c,measure_imu_time);
                     }else{
                        printrobot(mode,sd_client,"Monitoraggio della posizione in attivazione\n");
                     }
                  }else{
                     printrobot(mode,sd_client,"Errore: questa funzionalita' e' disponibile soltanto in modalita' Socket\n");
                  }
                  break;
               case '6':
                  printf("Salva misurazioni ambientali sul Database\n");
                  database('e',fd_i2c);
                  printrobot(mode,sd_client,"Dati salvati sul Database\n");
                  break; 
               case '7':
                  printf("Salva misurazioni inerziali sul Database\n");
                  database('i',fd_i2c);
                  printrobot(mode,sd_client,"Dati salvati sul Database\n");
                  break; 
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '3':
            printf("Movimento - ");
            switch(ch[1]){
               case '1':
                  printf("Accensione dei Motori\n");
                  e12volt_on();
                  printrobot(mode,sd_client,"12 Volt abilitati. Motori accesi\n");
                  break;
               case '2':
                  printf("Spegnimento dei Motori\n"); 
                  e12volt_off();
                  printrobot(mode,sd_client,"12 Volt disabilitati. Motori spenti\n");   
                  break;
               case '3':
                  printf("Spostamento manuale motori e sonar\n");
                  if((mode==0)||(mode==4)){
                     printf("TASTI FRECCIA: movimento motori\n");
                     printf("BARRA SPAZIATRICE: frena\n");
                     printf("TASTO 'C': suona clacson\n");
                     printf("TASTO 'P': muovi avanti e indietro fino ad ostacolo\n");
                     printf("TASTO 'L': movimento sonar in senso antiorario\n");
                     printf("TASTO 'K': movimento sonar in senso orario\n");
                     printf("TASTO 'R': reset posizioni\n");
                     printf("TASTO 'X': uscita\n");
                  }
                  movementchildpid=fork();
                  if(movementchildpid==0){
                     movement(mode,sd_client,pos);
                  }else{
                     waitpid(movementchildpid,NULL,0);
                     printf("Posizione motore stepper: %d\n",pos[0]);
                     printf("Posizione sonar: %d\n",pos[1]);
                     printrobot(mode,sd_client,"Fine spostamento manuale\n");
                  }
                  break;
               case '4':
                  printf("Spostamento automatico ruote anteriori\n");
                  step=0;
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Posizione motore anteriore (da -7 a 7):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     step=atoi(buffer);
                     par=step;
                  }else if(mode==2){
                     step=par;
                  }else if(argc<=2){
                     printf("Posizione motore anteriore (da -7 a 7): ");
                     scanf("%d",&step);
                     par=step;
                  }else{
                     step=par;
                  }
                  if(motor_stepper_set(pos,step)==0){
                     sprintf(buffer,"Spostamento motore anteriore eseguito. Posizione attuale: %d\n",pos[0]);
                     printrobot(mode,sd_client,buffer);
                  }else{
                     printrobot(mode,sd_client,"Errore: Spostamento motore anteriore non eseguito\n");
                  }
                  break;
               case '5':
                  printf("Avanzamento automatico ruote posteriori\n");
                  step=0;
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Avanzamento motore posteriore (in step, negativi se deve indietreggiare):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     step=atoi(buffer);
                     par=step;
                  }else if(mode==2){
                     step=par;
                  }else if(argc<=2){
                     printf("Avanzamento motore posteriore (in step, negativi se deve indietreggiare): ");
                     scanf("%d",&step);
                     par=step;
                  }else{
                     step=par;
                  }
                  int finalstep=motor_dc_set(fd_i2c,pos,step);
                  if(finalstep==-90){
                     printrobot(mode,sd_client,"Errore: Avanzamento motore posteriore non eseguito\n");
                  }else{
                     sprintf(buffer,"Avanzamento motore posteriore: %d step eseguito/i\n",finalstep);
                     printrobot(mode,sd_client,buffer);
                  }
                  break;
               case '6':
                  printf("Spostamento automatico sonar\n");
                  step=0;
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Posizione sonar (da -7 a 7):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     step=atoi(buffer);
                     par=step;
                  }else if(mode==2){
                     step=par;
                  }else if(argc<=2){
                     printf("Posizione sonar (da -7 a 7): ");
                     scanf("%d",&step);
                     par=step;
                  }else{
                     step=par;
                  }
                  if(motor_sonar_set(pos,step)==0){
                     sprintf(buffer,"Spostamento sonar eseguito. Posizione attuale: %d\n",pos[1]);
                     printrobot(mode,sd_client,buffer);
                  }else{
                     printrobot(mode,sd_client,"Errore: Spostamento sonar non eseguito\n");
                  }
                  break;
               case '7':
                  printf("Visualizza posizioni (motore anteriore e sonar)\n");
                  sprintf(buffer,"Posizione motore stepper: %d   Posizione sonar: %d\n",pos[0],pos[1]);
                  printrobot(mode,sd_client,buffer);
                  break;
               case '8':
                  printf("Reset posizioni (motore anteriore e sonar)\n");
                  pos[0]=0;
                  pos[1]=0;
                  printrobot(mode,sd_client,"Posizioni del motore anteriore e del sonar resettate\n");
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '4':
            printf("Illuminazione - ");
            switch(ch[1]){
               case '1':
                  printf("Led destro\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Scegliere il colore (0 Spento - 1 Blu - 2 Verde - 3 Azzurro - 4 Rosso - 5 Viola - 6 Giallo - 7 Bianco):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     colorled=atoi(buffer);
                     par=colorled;
                  }else if(mode==2){
                     colorled=par;
                  }else if(argc<=2){
                     printf("Scegliere il colore (0 Spento - 1 Blu - 2 Verde - 3 Azzurro - 4 Rosso - 5 Viola - 6 Giallo - 7 Bianco): ");
                     scanf("%d",&colorled);
                     par=colorled;
                  }else{
                     colorled=par;
                  }
                  if(led('r',colorled)==0){
                     printrobot(mode,sd_client,"Colore del Led destro cambiato\n");
                  }else{
                     printrobot(mode,sd_client,"Errore: Colore del Led destro non cambiato\n");                  
                  }
                  break;
               case '2':
                  printf("Led sinistro\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Scegliere il colore (0 Spento - 1 Blu - 2 Verde - 3 Azzurro - 4 Rosso - 5 Viola - 6 Giallo - 7 Bianco):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     colorled=atoi(buffer);
                     par=colorled;
                  }else if(mode==2){
                     colorled=par;
                  }else if(argc<=2){
                     printf("Scegliere il colore (0 Spento - 1 Blu - 2 Verde - 3 Azzurro - 4 Rosso - 5 Viola - 6 Giallo - 7 Bianco): ");
                     scanf("%d",&colorled);
                     par=colorled;
                  }else{
                     colorled=par;
                  }
                  if(led('l',colorled)==0){
                     printrobot(mode,sd_client,"Colore del Led sinistro cambiato\n");
                  }else{
                     printrobot(mode,sd_client,"Errore: Colore del Led sinistro non cambiato\n");                  
                  }
                  break;
               case '3':
                  printf("Frecce\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Definire quale freccia accendere (0 = Nessuna, 1 = Destra, 2 = Sinistra, 3 = Entrambe):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     turnsignal=atoi(buffer);
                     par=turnsignal;
                  }else if(mode==2){
                     turnsignal=par;
                  }else if(argc<=2){
                     printf("Definire quale freccia accendere (0 = Nessuna, 1 = Destra, 2 = Sinistra, 3 = Entrambe): ");
                     scanf("%d",&turnsignal);
                     par=turnsignal;
                  }else{
                     turnsignal=par;
                  }
                  if(turnsignalschildpid!=0){
                     kill(turnsignalschildpid,SIGTERM);
                     turnsignalschildpid=0;
                  }
                  if(turnsignal>3){
                     printrobot(mode,sd_client,"Errore: selezionare correttamente la freccia da accendere\n"); 
                  }else if(turnsignal>0){
                     turnsignalschildpid=fork();
                     if(turnsignalschildpid==0){
                        ledturnsignals(turnsignal);
                     }else{
                        printrobot(mode,sd_client,"Freccia(e) attivata(e)\n");                
                     }
                  }else{
                     led('l',0);
                     led('r',0);
                     printrobot(mode,sd_client,"Freccia(e) disattivata(e)\n");
                  }            
                  break;
               case '4':
                  printf("Casuale\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Velocita' variazione (in millisecondi, 0 = Stop):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     colorspeed=atoi(buffer);
                     par=colorspeed;
                  }else if(mode==2){
                     colorspeed=par;
                  }else if(argc<=2){
                     printf("Velocita' variazione (in millisecondi, 0 = Stop): ");
                     scanf("%d",&colorspeed);
                     par=colorspeed;
                  }else{
                     colorspeed=par;
                  }
                  if(colorchildpid!=0){
                     kill(colorchildpid,SIGTERM);
                     colorchildpid=0;
                  }
                  if(colorspeed>0){
                     colorchildpid=fork();
                     if(colorchildpid==0){
                        randomcolorled(colorspeed);
                     }else{
                        printrobot(mode,sd_client,"Cambio casuale del colore dei Led attivato\n");                
                     }
                  }else{
                     printrobot(mode,sd_client,"Cambio casuale del colore dei Led interrotto\n");
                  }            
                  break;
               case '5':
                  printf("Faro anteriore\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Scegliere modalita' (0 Spento - 1 Acceso):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     bigled=atoi(buffer);
                     par=bigled;
                  }else if(mode==2){
                     bigled=par;
                  }else if(argc<=2){
                     printf("Scegliere modalita' (0 Spento - 1 Acceso): ");
                     scanf("%d",&bigled);
                     par=bigled;
                  }else{
                     bigled=par;
                  }
                  if(led('b',bigled)==0){
                     if(bigled==1){
                        printrobot(mode,sd_client,"Faro anteriore acceso\n");
                     }else{
                        printrobot(mode,sd_client,"Faro anteriore spento\n");
                     }
                  }else{
                     printrobot(mode,sd_client,"Errore: Stato del Faro anteriore non modificato\n");                  
                  }
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '5':
            printf("GPS - ");
            system("stty -F /dev/ttyS3 115200 min 0 time 0 -ixon -opost -isig -iexten -echo -echoe -echoctl -echoke");
            switch(ch[1]){
               case '1':
                  printf("Orario e Coordinate satellitari\n");
                  GPS=gps();
                  if(GPS.quality!=0){
                     sprintf(buffer,"Orario: %s   Latitudine: %.4f %c   Longitudine: %.4f %c   Altitudine: %.2f metri   Satelliti disponibili: %d   Segnale GPS: OK\n",GPS.time_hms,GPS.latitude,GPS.latitude_d,GPS.longitude,GPS.longitude_d,GPS.altitude,GPS.satellite);
                  }else{
                     sprintf(buffer,"Orario: %s   Latitudine: %.4f %c   Longitudine: %.4f %c   Altitudine: %.2f metri   Satelliti disponibili: %d   Segnale GPS: ASSENTE\n",GPS.time_hms,GPS.latitude,GPS.latitude_d,GPS.longitude,GPS.longitude_d,GPS.altitude,GPS.satellite);
                  }                
                  printrobot(mode,sd_client,buffer);
                  break;
               case '2':
                  printf("Stringa NMEA\n");
                  GPS=gps();
                  sprintf(buffer,"Stringa NMEA: %s\n",GPS.nmea);
                  printrobot(mode,sd_client,buffer);
                  break;
               case '3':
                  printf("Converti Coordinate per Google Maps\n");
                  GPS=gps_google();
                  sprintf(buffer,"Latitudine: %f   Longitudine: %f\n",GPS.latitude_g,GPS.longitude_g);
                  printrobot(mode,sd_client,buffer);
                  break;
               case '4':
                  printf("Salva dati sul Database\n");
                  database('g',fd_i2c);
                  printrobot(mode,sd_client,"Dati salvati sul Database\n");
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '6':
            printf("Altre funzionalita' - ");                 
            switch(ch[1]){
               case '1':
                  printf("Individua luce e distanza\n"); 
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Scegliere modalita' (0 Misura solamente - 1 Individua luce - 2 Individua buio - 3 Individua distanza massima - 4 Individua distanza minima):\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     modechasing=atoi(buffer);
                     par=modechasing;
                  }else if(mode==2){
                     modechasing=par;
                  }else if(argc<=2){
                     printf("Scegliere modalita' (0 Misura solamente - 1 Individua luce - 2 Individua buio - 3 Individua distanza massima - 4 Individua distanza minima): ");
                     scanf("%d",&modechasing);
                     par=modechasing;
                  }else{
                     modechasing=par;
                  }
                  if(modechasing==0){
                     sprintf(buffer,"Misurazioni effettuate\n",chasing_light_range(0,fd_i2c,pos,-5,6,lightv,rangev),lightv[0],lightv[1],lightv[2],lightv[3],lightv[4],lightv[5],lightv[6],lightv[7],lightv[8],lightv[9],lightv[10],lightv[11]);
                     printrobot(mode,sd_client,buffer);
                  }else if(modechasing==1){
                     sprintf(buffer,"Massima luminosita' in posizione %d [%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d]\n",chasing_light_range(1,fd_i2c,pos,-5,6,lightv,rangev),lightv[0],lightv[1],lightv[2],lightv[3],lightv[4],lightv[5],lightv[6],lightv[7],lightv[8],lightv[9],lightv[10],lightv[11]);
                     printrobot(mode,sd_client,buffer);
                  }else if(modechasing==2){
                     sprintf(buffer,"Minima luminosita' in posizione %d [%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d]\n",chasing_light_range(2,fd_i2c,pos,-5,6,lightv,rangev),lightv[0],lightv[1],lightv[2],lightv[3],lightv[4],lightv[5],lightv[6],lightv[7],lightv[8],lightv[9],lightv[10],lightv[11]);
                     printrobot(mode,sd_client,buffer);
                  }else if(modechasing==3){
                     sprintf(buffer,"Massima distanza in posizione %d [%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d]\n",chasing_light_range(3,fd_i2c,pos,-5,6,lightv,rangev),rangev[0],rangev[1],rangev[2],rangev[3],rangev[4],rangev[5],rangev[6],rangev[7],rangev[8],rangev[9],rangev[10],rangev[11]);
                     printrobot(mode,sd_client,buffer);
                  }else if(modechasing==4){
                     sprintf(buffer,"Minima distanza in posizione %d [%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d]\n",chasing_light_range(4,fd_i2c,pos,-5,6,lightv,rangev),rangev[0],rangev[1],rangev[2],rangev[3],rangev[4],rangev[5],rangev[6],rangev[7],rangev[8],rangev[9],rangev[10],rangev[11]);
                     printrobot(mode,sd_client,buffer);   
                  }else{
                     printrobot(mode,sd_client,"Errore: Nessuna misurazione effettuata. Scegliere correttamente.\n");
                  }
                  break;
               case '2':
                  printf("Visualizza carica della batteria\n");
                  if(battery_status(&batteryvalue)==1){
                     sprintf(buffer,"Carica della batteria: %d%% (IN CARICA)\n",batteryvalue);
                  }else{
                     sprintf(buffer,"Carica della batteria: %d%%\n",batteryvalue);
                  }
                  printrobot(mode,sd_client,buffer);
                  break;
               case '3':
                  printf("Visualizza credito residuo (solo SIM TIM)\n");
                  system("stty -F /dev/ttyS2 115200 min 0 time 0 -ixon -opost -isig -iexten -echo -echoe -echoctl -echoke");                   
                  credit=(float)sms('c',buffer)/(float)100;
                  sprintf(buffer,"Credito residuo: %.2f euro\n",credit);
                  printrobot(mode,sd_client,buffer);
                  break;
               case '9':
                  printf("Clacson General Lee\n");
                  horn_dixie();   
                  sprintf(buffer,"General Lee\n");
                  printrobot(mode,sd_client,buffer);
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '7':
            printf("Script - "); 
            switch(ch[1]){
               case '1':
                  printf("Visualizza lista degli Script\n");
                  struct dirent **namelist;
                  int numscript;
                  char buffertemp[20];
                  char del[]=".";
                  int scriptnumcode;
                  sprintf(buffer,"Lista degli Script: ");
                  numscript = scandir("script", &namelist, 0, alphasort);
                  for(i=0;i<numscript;i++){
                     sprintf(buffertemp,"%s;",namelist[i]->d_name);
                     scriptnumcode=atoi(strtok(buffertemp,del));
                     if(scriptnumcode>0){
                        sprintf(buffertemp,"%d; ",scriptnumcode);
                        strcat(buffer,buffertemp);
                     }
                  }
                  strcat(buffer,"\n");
                  printrobot(mode,sd_client,buffer);
                  break;
               case '2':
                  printf("Esecuzione di uno Script\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire il nome dello Script:\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     script_file=atoi(buffer);
                     par=script_file;
                  }else if(mode==2){
                     script_file=par;
                  }else if(argc<=2){
                     printf("Inserire il nome dello Script: ");
                     scanf("%d",&script_file);
                     par=script_file;
                  }else{
                     script_file=par;
                  }
                  int scriptchildpid=fork();
                  if(scriptchildpid==0){
                     sprintf(buffer,"script/%d.robot",script_file);
                     execl("./robot","./robot","-s",buffer,NULL);
                  }else{
			         int script_status;
                     wait(&script_status);
                     if((fd_motor=fopen("save/motor","r"))!=NULL){
                        fscanf(fd_motor,"%d,%d",&pos[0],&pos[1]);
                        fclose(fd_motor);
                     }else{
                        printf("Errore: Impossibile leggere le posizioni dei motori");
                     }
                     if((fd_webcam=fopen("save/webcam","r"))!=NULL){
                        fscanf(fd_webcam,"%d,%d,%d,%s",&webcam_time,&webcam_fps,&webcam_resolution,&webcam_res);
                        fclose(fd_webcam);
                     }else{
                        printf("Errore: Impossibile leggere la configurazione della webcam\n");
                     }
                     if(script_status==0){
                        sprintf(buffer,"Script %d Eseguito\n",script_file);
                     }else{
                        sprintf(buffer,"Errore: Script %d non Eseguito\n",script_file);
                     }		   
                     printrobot(mode,sd_client,buffer);
                  }
                  break;
               case '3':
                  printf("Visualizza uno Script\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire il nome dello Script:\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     script_file=atoi(buffer);
                     par=script_file;
                  }else if(mode==2){
                     script_file=par;
                  }else if(argc<=2){
                     printf("Inserire il nome dello Script: ");
                     scanf("%d",&script_file);
                     par=script_file;
                  }else{
                     script_file=par;
                  }
                  sprintf(buffer,"script/%d.robot",script_file);
                  if((fd_script_r=fopen(buffer,"r"))==NULL){
                     printf("\nErrore: Impossibile aprire lo script\n");
                     //exit(1);
                  }else{
                     char scriptbuffer[1000];
                     for(i=0;i<1000;i++){
                        scriptbuffer[i]='\0';
                     }
                     printf("\033[31;43;1mINIZIO DELLO SCRIPT NUMERO %d\033[0m\033[32;1m\n",script_file);
                     while(!feof(fd_script_r)){
                        fgets(buffer,50,fd_script_r);
                        strcat(scriptbuffer,buffer);
                     }
                     fclose(fd_script_r);
                     strcat(scriptbuffer,"\n");
                     printrobot(mode,sd_client,scriptbuffer);
                     printf("\033[31;43;1m\nFINE DELLO SCRIPT\033[32;0m\n");
                  }
                  break;
               case '4':
                  printf("Elimina uno Script\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire il nome dello Script:\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     script_file=atoi(buffer);
                     par=script_file;
                  }else if(mode==2){
                     script_file=par;
                  }else if(argc<=2){
                     printf("Inserire il nome dello Script: ");
                     scanf("%d",&script_file);
                     par=script_file;
                  }else{
                     script_file=par;
                  }
                  sprintf(buffer,"script/%d.robot",script_file);
                  if(remove(buffer)==0){
                     sprintf(buffer,"Script %d Eliminato\n",script_file);
                  }else{
                     sprintf(buffer,"Errore: Script %d non Eliminato\n",script_file);
                  }
                  printrobot(mode,sd_client,buffer);
                  break;
               case '5':
                  printf("Registrazione di uno Script\n");
                  if(mode==1){
                     strcpy(buffer,"Richiesta Parametro - Inserire il nome dello Script:\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     for(i=0;i<150;i++){
                        buffer[i]='\0';
                     }
                     recv(sd_client, buffer, sizeof(buffer),0); 
                     script_file_s_t=atoi(buffer);
                     par=script_file_s_t;
                  }else if(mode==2){
                     script_file_s_t=par;
                  }else if(argc<=2){
                     printf("Inserire il nome dello Script: ");
                     scanf("%d",&script_file_s_t);
                     par=script_file_s_t;
                  }else{
                     script_file_s_t=par;
                  }
                  if(save_script==0){
                     save_script=1;
                     script_file_s=script_file_s_t;
                     sprintf(buffer,"script/%d.robot",script_file_s);
                     if((fd_script_s=fopen(buffer,"w"))!=NULL){
                        fprintf(fd_script_s,"<ROBOT>");     
                        fclose(fd_script_s);
                     }else{
                        printf("Errore: Impossibile inizializzare lo script\n");
                     }
                     sprintf(buffer,"Registrazione in corso sul file %d\n",script_file_s);
                  }else{
                     sprintf(buffer,"Errore: Un'altra registrazione e' in corso\n");
                  }
                  printrobot(mode,sd_client,buffer);
                  break;
               case '6':
                  printf("Interrompi registrazione in corso\n");
                  if(save_script==1){
                     save_script=0;
                     sprintf(buffer,"script/%d.robot",script_file_s);
                     if((fd_script_s=fopen(buffer,"a"))!=NULL){
                        fprintf(fd_script_s,"\n<EXIT>");     
                        fclose(fd_script_s);
                     }else{
                        printf("Errore: Impossibile terminare lo script\n");
                     }
                     sprintf(buffer,"Registrazione interrotta sul file %d\n",script_file_s);
                  }else{
                     sprintf(buffer,"Errore: nessuna registrazione in corso\n");
                  }
                  printrobot(mode,sd_client,buffer);
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '8':
            printf("Gestione comunicazioni - ");                 
            switch(ch[1]){
               case '1':
                  printf("Abilita gestione del robot tramite socket\n");
                  if(mode!=1){                    
                     if((sd_server = socket(AF_INET, SOCK_STREAM,0))<0){
                        printf("Errore nella creazione del Server\n");
                     }else{
                        server_addr.sin_family = AF_INET;
                        server_addr.sin_port = htons(4400);
                        server_addr.sin_addr.s_addr = INADDR_ANY;
                        int bindstatus=0;
                        do{
                           if(bind(sd_server,(struct sockaddr *)&server_addr, sizeof(server_addr))<0){
                              bindstatus++;
                              if(bindstatus==1){
                                 fflush(stdin);
                                 char risp;
                                 printf("Errore: Socket ancora occupato. [a]ttendere alcuni secondi o [c]ambiare porta? ");
                                 getchar();
                                 risp=getchar();
                                 if(risp=='c'){
                                    int port2;
                                    printf("Inserire nuova porta: ");
                                    scanf("%d",&port2);
                                    server_addr.sin_port = htons(port2);                              
                                 }else{
                                    printf("\n");
                                 }
                              }else{
	                             printf("\033[ARiconnessione... [Tentativo: %d]\n",bindstatus-1);
                                 sleep(3);
                              }
                           }else{
                              bindstatus=0;
                              listen(sd_server,1);
                              socklen_t address_size = sizeof(client_addr);
                              printf("In attesa di un client sulla porta %d... (premere ^C per terminare)\n",htobe16(server_addr.sin_port));
                              if((sd_client = accept(sd_server, (struct sockaddr *)&client_addr, &address_size))<0){
                                 printf("Errore nella chiamata accept\n");
                              }else{
                                 char *ip_address = inet_ntoa(client_addr.sin_addr);
                                 printf("Stabilita una connessione con il client %s\n",ip_address);
                                 mode=1;
                              }
                           }
                        }while(bindstatus!=0);
                     }                   
                  }else{
                     printf("Errore: Connessione tramite socket gia' attivata\n");
                  }
                  break;
               case '2':
                  printf("Abilita gestione del robot tramite sms\n");
                  if(mode!=2){
                     system("stty -F /dev/ttyS2 115200 min 0 time 0 -ixon -opost -isig -iexten -echo -echoe -echoctl -echoke"); 
                     mode=2;
                     printf("Modalita' sms attivata\n");
                  }else{
                     printf("Errore: sms gia' attivati\n");
                  }
                  break;
               case '3':
                  printf("Abilita gestione del robot tramite console\n");
                  if(mode==1){
                     strcpy(buffer,"Connessione tramite socket disattivata\n");
                     send(sd_client,buffer,strlen(buffer),0);
                     close(sd_client);
	                 close(sd_server);
                     mode=4;
                     printf("Modalita' Socket disattivata\n");
                  }else if(mode==2){
                     mode=4;
                     printf("Modalita' SMS disattivata\n");
                  }else{
                     printf("Errore: Console gia' attivata\n");
                  }
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '9':
            printf("Uscita - ");
            switch(ch[1]){
               case '1':
                  printf("Esci dal software di gestione\n\033[m");
                  if((argc==1)||(mode==4)){
                     system("clear");
                  }
                  closerobot(fd_i2c,pos,webcam_time,webcam_fps,webcam_resolution,webcam_res);
                  exit(0);
                  break;
               case '2':
                  printf("Spegni il robot\n\033[m");
                  if(mode==1){
                     close(sd_client);
	                 close(sd_server);
                  }
                  system("init 0");
                  break;
               default:
                  printf("Errore nella scelta\n");
                  break;
            }
            break;
         case '!':
            /////////////////
            //LAVORI IN CORSO
            printf("RISERVATO PER FUNZIONALITA' ANCORA NON ULTIMATE\n");
            movement_casual(fd_i2c,pos);

            break;
         default:
            printf("\nErrore nella scelta\n");
            break; 
      }
      if((save_script==1)&&(strcmp(ch,"75"))&&(strcmp(ch,"33"))&&(ch[0]!='8')&&(ch[0]!='9')){
         sprintf(buffer,"script/%d.robot",script_file_s);
         if((fd_script_s=fopen(buffer,"a"))!=NULL){
            if(par==-1){
               fprintf(fd_script_s,"\n%c%c;\nms 500;",ch[0],ch[1]);
            }else{
               fprintf(fd_script_s,"\n%c%c %d;\nms 500;",ch[0],ch[1],par);     
            }
            fclose(fd_script_s);
         }else{
            printf("Errore: Impossibile registrare il comando ricevuto\n");
         }
      }
      par=-1;

      if(((argc==1)&&(mode==0))||(mode==4)){
         getchar();
         getchar();
      }
   }while((argc==1)||(mode!=0)||(!strcmp(argv[1],"-s")));
   closerobot(fd_i2c,pos,webcam_time,webcam_fps,webcam_resolution,webcam_res);
}
